unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, ExtCtrls,
  StdCtrls;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Label1: TLabel;
    PaintBox1: TPaintBox;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure PaintBox1Paint(Sender: TObject);
    procedure PaintBox1Resize(Sender: TObject);
  private
    { private declarations }
    FBitmap: TBitmap;
    a, b, c: Double;
    zMax: Integer;
    Stopped: Boolean;
    procedure Bildaufbau;
    procedure Zeichnen(var x, y: Double; z1, z2: Integer);
  public
    { public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

uses
  Math;

const
  dz = 1000;

procedure TForm1.Bildaufbau;
var
  z: Integer;
  x, y: Double;
begin
  Stopped := false;
  if FBitmap = nil then
    FBitmap := TBitmap.Create;
  z := 0;
  x := 0;
  y := 0;
  while (z <= zMax) and not Stopped do begin
    Zeichnen(x, y, z, z + dz-1);
    Paintbox1.Invalidate;
    z := z + dz;
    label1.Caption := IntToStr(z);
    Application.ProcessMessages;
  end;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  Button2.Show;
  Button1.Hide;
  Bildaufbau;
  Button2.Hide;
  Button1.Show;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  Stopped := true;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin            {
  a := 500;
  b := 0.21;
  c := 100;
  zMax := 150000;
                }
  a := 366;
  b := 0.07;
  c := 50;
  zMax := 1000000;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  FBitmap.Free;
end;

procedure TForm1.PaintBox1Paint(Sender: TObject);
begin
  if FBitmap <> nil then
    Paintbox1.Canvas.Draw(0, 0, FBitmap);
end;

procedure TForm1.PaintBox1Resize(Sender: TObject);
var
  x, y: Double;
begin
  x := 0.0;
  y := 0.0;
  Zeichnen(x, y, 0, zmax);
  Paintbox1.Invalidate;
end;

procedure TForm1.Zeichnen(var x, y: Double; z1, z2: Integer);
const
//  MULT = 0.05;
  MULT = 0.2;
var
  i: Integer;
  xx, yy: Double;
  u, v: Integer;
begin
  if FBitmap = nil then
    FBitmap := TBitmap.Create;
  if z1 = 0 then
  begin
    FBitmap.SetSize(Paintbox1.Width, Paintbox1.Height);
    FBitmap.Canvas.Brush.Color := clWhite;
    FBitmap.Canvas.Brush.Style := bsSolid;
    FBitmap.Canvas.FillRect(0, 0, FBitmap.Width, FBitmap.Height);
  end;
  u := FBitmap.Width div 2;
  v := FBitmap.Height div 2;
  for i:=z1 to z2 do
  begin
    FBitmap.Canvas.Pixels[u+round(x*MULT), v+round(y*MULT)] := clBlack;
    xx := y - sign(x) * abs(b * x - c);
    yy := a - x;
    x := xx;
    y := yy;
  end;
end;
       {
begin

Sub graph (u, v, a, b, c, z)
    text9.Text = ""
    x = 0: y = 0
    For i = 0 To z
      PSet (u + x, v + y)
      xx = y + Sgn(x) * Abs(b * x - c)
      yy = a - x
      x = xx
      y = yy
      If i / 10000 = Int(i / 10000) Then text9.Text = Str$(i)
    Next i
    text9.Text = "Ende"
End Sub.
        }
end.

